# Application to collect goodput. The number of
# recevied bytes is saved in bytes_ and the number of received packtes
# is saved in packets_

Class Application/TraceReceiver -superclass Application

Application/TraceReceiver instproc init {args} {
    $self set packets_ 0
    $self set bytes_ 0
    eval $self next $args
}

Application/TraceReceiver instproc recv {byte} {
    $self instvar bytes_ packets_
    set bytes_ [expr $bytes_ + $byte]
    incr packets_
    return $bytes_
}

# Experiment calls this function to return a result back to the dispatcher
# via the worker and farmer.
# This proc is also included tcl-dipatcher.tcl, you don't need to
# include it as follows if you already source tcl-dispatcher.tcl.
proc return_result { result } {
  set id [pid]
  # Necessary for new-farmer, but not for old.
  set outf [open /tmp/exp_result.$id w]
  puts -nonewline $outf $result
  # For old farmer
  #set outf [open /tmp/trace.erica.$id w]
  #puts $outf $result
  # end old farmer
  close $outf
}
